/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2004, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
NetUsage ToolItem

*/

//
// FIXIT: animation happens only one window!
//

var netusageobj = {
	animating: false,
	anipos: 9,
	anistep: 1,
	anitimer: null,

	usageprogressbar: null,

	observe: function (subject, topic, data) {
     	if (topic == 'timer-callback') {
     		//alert('hi');
			this.anitimercallback();
		} else {
			switch (data) {
			case 'draw':
				try {
				this.animating = false;
				var usagedata = Components.classes["@mozilla.org/netusagecom;1"].getService().QueryInterface(Components.interfaces.nsINetUsageData);
				this.drawusage(usagedata);
				} catch(e) { alert(e); }
				break;

			case 'start':
				try {
				this.animating = true;
				this.anitimer.init(this, 100, this.anitimer.TYPE_REPEATING_SLACK);
				} catch(e) { alert(e); }
				break;

			case 'error':
				this.animating = false;
				break;

			default:
				alert(data);

			}
		}
	},

	anitimercallback: function() {
		if (this.anipos >= 9 || this.anipos <= 5) {
			this.anistep = -this.anistep;
		}
		if (this.animating || (!this.animating && this.anipos < 9)) {
			this.usageprogressbar.style.MozOpacity = '0.'+this.anipos;
			this.anipos += this.anistep;
		} else {
			// waited for cycle to complete
			this.anitimer.cancel();
			this.usageprogressbar.style.MozOpacity = '1';
			this.anipos = 9;
			this.anistep = 1;
		}

	},

	drawusage: function(usagedata) {

		if (!document.getElementById('usagebtn-container')) return;

		var mblbl = document.getElementById('usagebar_myusage');
		var pclbl = document.getElementById('usagebar_myusagepc');

		var barG = document.getElementById('usagebarG');
		//var barW = document.getElementById('usagebarW');
		var barR = document.getElementById('usagebarR');
		var barB = document.getElementById('usagebarB');
		var barY = document.getElementById('usagebarY');
		var usagepbar = document.getElementById('usagepbar');
		var usagemarker = document.getElementById('usagebarMM');
		//var baricon = document.getElementById('usagebarIcon');

		var usedpc = parseInt(usagedata.usage/usagedata.quota*100);

		var datepc = ((new Date).getTime() - usagedata.startdate) / (usagedata.enddate - usagedata.startdate)*100;

		if (usedpc <= 100) {
			barG.width = parseInt((usedpc)/100*100);
			barR.setAttribute('width', 0);
			//barW.setAttribute('width', 100-parseInt((usedpc)/100*100) /* parseInt((100-usedpc)/100*100) */ );
			usagemarker.width = parseInt((datepc)/100*100)+4;
		} else {
			//var barmax = Math.ceil(usedpc/200)*200;
			var barmax = usedpc;
			barG.setAttribute('width', parseInt((100)/barmax*100));
			barR.setAttribute('width', 100-parseInt((100)/barmax*100)/*parseInt((usedpc-100)/barmax*100)*/);
			//barW.setAttribute('width', 0);
			usagemarker.width = parseInt((datepc)/barmax*100)+4;
		}

		var usedpopc = parseInt(usagedata.usagepo/usagedata.quotapo*100);
		if (usedpopc <= 100) {
			barB.width = parseInt((usedpopc)/100*100);
			barY.setAttribute('width', 0);
		} else {
			//var barmax = Math.ceil(usedpopc/200)*200;
			var barmax = usedpopc;
			barB.setAttribute('width', parseInt((100)/barmax*100));
			barY.setAttribute('width', 100-parseInt((100)/barmax*100));
		}

		// force repaint
		usagepbar.width = 100;

		//mblbl.setAttribute('value', usagedata.usage + '/' + usagedata.quota + ' MB');
		pclbl.setAttribute('value', usedpc + '%');
		//baricon.setAttribute('src', 'chrome://netusagebar/content/skin/icon.png');

		// set tooltip


		with (document.getElementById('usagedetails-planname')) {
			if (usagedata.planname) { style.display = '';
				value = usagedata.planname;
			} else style.display = 'none';
		}
		with (document.getElementById('usagedetailsr-headings')) {
			if (usagedata.quotapo) { style.display = '';
				value = usagedata.planname;
			} else style.display = 'none';
		}


		document.getElementById('usagedetails-usedquota').value = usagedata.usage+' / '+usagedata.quota;
		with (document.getElementById('usagedetails-usedquotapo')) {
			if (usagedata.usagepo > 0) { style.display = '';
				value = usagedata.usagepo+' / '+usagedata.quotapo;
			} else style.display = 'none';
		}

		document.getElementById('usagedetailsr-upload').style.display = (usagedata.upload > 0 || usagedata.uploadpo > 0) ? '' : 'none';
		document.getElementById('usagedetails-upload').value = usagedata.upload;
		document.getElementById('usagedetailsr-download').style.display = (usagedata.download > 0 || usagedata.downloadpo > 0) ? '' : 'none';
		document.getElementById('usagedetails-download').value = usagedata.download;

		with (document.getElementById('usagedetails-downloadpo')) {
			if (usagedata.downloadpo > 0) { style.display = '';
					value = usagedata.downloadpo;
			} else style.display = 'none';
		}
		with (document.getElementById('usagedetails-uploadpo')) {
			if (usagedata.uploadpo > 0) { style.display = '';
				value = usagedata.uploadpo;
			} else style.display = 'none';
		}

		// remaining / excess
		var mbremaining = usagedata.quota - usagedata.usage;
		var mbremainingpo = usagedata.quotapo - usagedata.usagepo;

		document.getElementById('usagedetailsr-remain').style.display = (mbremaining > 0 || mbremainingpo > 0) ? '' : 'none';
		document.getElementById('usagedetailsr-excess').style.display = (mbremaining < 0 || mbremainingpo < 0) ? '' : 'none';

		if (mbremaining > 0) {
			with (document.getElementById('usagedetails-remain')) { value = mbremaining; };
			with (document.getElementById('usagedetails-excess')) { value = ''; };
		} else if (mbremaining < 0) {
			with (document.getElementById('usagedetails-remain')) { value = ''; };
			with (document.getElementById('usagedetails-excess')) { value = Math.abs(mbremaining); };
		} else {
			with (document.getElementById('usagedetails-remain')) { value = '' };
			with (document.getElementById('usagedetails-excess')) { value = ''; };
		}
		if (mbremainingpo > 0) {
			with (document.getElementById('usagedetails-remainpo')) { style.display = ''; value = mbremainingpo; };
			with (document.getElementById('usagedetails-excesspo')) { style.display = 'none'; value = ''; };
		} else if (mbremaining < 0) {
			with (document.getElementById('usagedetails-remainpo')) { style.display = 'none'; value = ''; };
			with (document.getElementById('usagedetails-excesspo')) { style.display = ''; value = Math.abs(mbremainingpo); };
		} else {
			with (document.getElementById('usagedetails-remainpo')) { style.display = 'none'; value = '' };
			with (document.getElementById('usagedetails-excesspo')) { style.display = 'none'; value = ''; };
		}



		var daysremaining = ((usagedata.enddate - (new Date).getTime())/86400000);
		var hrsr = Math.round((usagedata.enddate - (new Date).getTime())/3600000);
		document.getElementById('usagedetails-daysr').value = Math.floor(hrsr / 24)+' d' + ((hrsr % 24 != 0) ? '    '+(hrsr % 24)+' h' : '');
		document.getElementById('usagedetails-daysrav').value = Math.min(Math.abs(mbremaining), Math.max(0, Math.round((usagedata.quota - usagedata.usage)/daysremaining)));
		with (document.getElementById('usagedetails-daysravpo')) {
			if (usagedata.quotapo > 0) { style.display = '';
				value = Math.min(Math.abs(mbremainingpo), Math.max(0, Math.round((usagedata.quotapo - usagedata.usagepo)/daysremaining)));
			} else style.display = 'none';
		}
	},

}


addEventListener('load', netusageload, false);

var observerSvc = Components.classes["@mozilla.org/observer-service;1"].getService().QueryInterface(Components.interfaces.nsIObserverService);
observerSvc.addObserver(netusageobj, 'netusage-update-gui', false);


function netusageload() {

	with (netusageobj) {
		usageprogressbar = document.getElementById('usageprogressbar');
		anitimer = Components.classes['@mozilla.org/timer;1'].createInstance(Components.interfaces.nsITimer);
	}

	var usagedata = Components.classes["@mozilla.org/netusagecom;1"].getService().QueryInterface(Components.interfaces.nsINetUsageData);
	if (usagedata.lastfetched != 0)
		netusageobj.drawusage(usagedata);
	else
		observerSvc.notifyObservers(this, 'netusage-update', 'actfirst');
}


function netusagevisit() {

	portnum = {'http': 80, 'https': 433 };

	var up = nuLoadPass('net:usage:bar');

	var usagedata = Components.classes["@mozilla.org/netusagecom;1"].getService().QueryInterface(Components.interfaces.nsINetUsageData);

	if (!usagedata.ispactive) return;

	switch (usagedata.ispusagepageauth) {

		case nuISPAuthBasic:

			if (usagedata.ispusagepageauthrealm) {
				var authman = Components.classes['@mozilla.org/network/http-auth-manager;1'].getService().QueryInterface(Components.interfaces.nsIHttpAuthManager);

				var urlexpr = /^(http|https):\/\/([a-z0-9.\-]+)\/([^\/]*\/)/g;
				var urla = urlexpr.exec(usagedata.ispusagepageurl);

				authman.setAuthIdentity(urla[2] , portnum[urla[1]], usagedata.ispusagepageauthrealm, urla[3], '', up[1], up[2]);
			}

			window._content.document.location = usagedata.ispusagepageurl;

			break;

		case nuISPAuthPost:
			var userpassstr = "username="+escape(up[1])+"&password="+escape(up[2]);
			var headerstr = "Content-Type: application/x-www-form-urlencoded\nContent-Length: "+userpassstr.length+"\n";
			var combinedstr = headerstr+"\n"+userpassstr;

			var postdata = Components.classes['@mozilla.org/io/string-input-stream;1'].createInstance(Components.interfaces.nsIStringInputStream);
			postdata.setData(combinedstr, combinedstr.length);
			//var headerdata = Components.classes['@mozilla.org/io/string-input-stream;1'].createInstance(Components.interfaces.nsIStringInputStream);
			//headerdata.setData(headerstr, headerstr.length);

			window.getBrowser().webNavigation.loadURI(usagedata.ispusagepageurl, Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE, null, postdata, null);

			break;
	}
}

function netusageget() {
	observerSvc.notifyObservers(this, 'netusage-update', 'usage');
}